"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tyr_1 = require("../tyr");
async function pathify(collection, columns) {
    var _a;
    if (columns) {
        for (const column of columns) {
            const { path } = column;
            if (!(path instanceof tyr_1.default.Path)) {
                try {
                    column.path = collection.parsePath(path);
                }
                catch (err) {
                    column.path = (_a = (await collection.findField(path))) === null || _a === void 0 ? void 0 : _a.path;
                }
            }
        }
    }
}
exports.pathify = pathify;
exports.createLogger = log => log
    ? message => {
        log.issues = log.issues || '';
        if (!log.issues.includes(message)) {
            log.issues += message + '<br>';
            console.warn(message);
        }
    }
    : message => console.warn(message);
//# sourceMappingURL=grid.js.map